#!/usr/bin/python3

import pynwp.migration as core
import sys


def validator(arguments):
    if not arguments.rootfs:
        return False
    else:
        return True


if __name__ == "__main__":
    arguments = core.CommandLineParser(sys.argv[1:], validator)

    message = "Transfer users"
    if not arguments.is_clean():
        print(message)

        factory_uid = 1000
        admin_uid = 1002
        admin_group_id = 111
        user_group_id = 112

        users_transfer = core.UsersTransfer(target_rootfs=arguments.rootfs_path())
        users_transfer.copy_users_changes(uid=[factory_uid, admin_uid])
        users_transfer.copy_existing_users(gid=admin_group_id, additional_gid=[user_group_id],
                                           except_uid=[factory_uid, admin_uid])
        users_transfer.copy_existing_users(gid=user_group_id, additional_gid=[], except_uid=[factory_uid, admin_uid])
    else:
        print(message + " - skipped")
