from .SystemService import SystemService


class IncrementalUpdates:
    def __init__(self, current_version, target_version, patches_path, rootfs, rootfs_src, rootfs_dflt, board_type):
        self.current_version = current_version
        self.target_version = target_version
        self.patches_path = patches_path
        self.rootfs = rootfs
        self.rootfs_src = rootfs_src
        self.rootfs_dflt = rootfs_dflt
        self.board_type = board_type

    def execute_patches_found_by(self, patches_finder):
        patches = patches_finder(self.current_version, self.target_version, self.patches_path)
        for patch in patches:
            SystemService.apply_patch(patch=patch, rootfs=self.rootfs, board_type=self.board_type, rootfs_src=self.rootfs_src, rootfs_dflt=self.rootfs_dflt)

    def execute_permanent_patches(self):
        self.execute_patches_found_by(SystemService.get_permanent_patches)

    def execute_upgrade_patches(self):
        self.execute_patches_found_by(SystemService.get_upgrade_patches)
