from .DeviceInfo import DeviceInfo
from subprocess import Popen, PIPE
import os


class SystemUtil:
    @staticmethod
    def board_type():
        env = os.environ.copy()
        env["PATH"] = "/usr/cli:" + env["PATH"]
        p = Popen('model', stdin=PIPE, stdout=PIPE, stderr=PIPE, env=env)
        output, err = p.communicate()

        if p.returncode is not 0:
            raise Exception("Command 'model' was exited with error: {0} {1}.".format(p.returncode, err))

        return DeviceInfo(output).board_type()
